﻿using System;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Threading;

namespace TaskBasedWebOperations.Web
{
  [ServiceContract(Namespace = "")]
  [SilverlightFaultBehavior]
  [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
  public class Service1
  {
    private const int Delay = 2000;

    [OperationContract]
    public void DoAction(string s, double d, DateTime t)
    {
      Thread.Sleep(Delay);
    }

    [OperationContract]
    public string DoThis(string s)
    {
      Thread.Sleep(Delay);
      return s + DateTime.Now.ToLongTimeString();
    }

    [OperationContract]
    public int DoThat(string s, int n)
    {
      Thread.Sleep(Delay);
      return s.Length * n;
    }

    [OperationContract]
    public void DoException()
    {
      Thread.Sleep(Delay);
      throw new InvalidOperationException("This is a test.");
    }

    [OperationContract]
    public void DoTimeout()
    {
      Thread.Sleep(int.MaxValue);
    }
  }
}
