﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Net;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using TaskBasedWebOperations.ServiceReference1;

namespace TaskBasedWebOperations
{
  public partial class MainPage : UserControl
  {
    public MainPage()
    {
      InitializeComponent();
    }

    private async void btn1_Click(object sender, RoutedEventArgs e)
    {
      int result = 0;
      try
      {
        var client = new Service1Client();

        info.Text = "DoAction";
        await client.DoActionTaskAsync("xxx", 4.5, DateTime.Now);

        info.Text = "DoThis";
        var result1 = await client.DoThisTaskAsync("Hallo");

        info.Text = "DoThat";
        result = await client.DoThatTaskAsync(result1, 43);
        info.Text = "Ready";
      }
      catch (Exception ex)
      {
        info.Text = ex.Message;
      }
    }

      private async void btn2_Click(object sender, RoutedEventArgs e)
      {
        try
        {
          info.Text = "Wait for exception...";
          await new Service1Client().DoExceptionTaskAsync();
        }
        catch (Exception ex)
        {
          info.Text = ex.Message;
        }
      }

      private async void btn3_Click(object sender, RoutedEventArgs e)
      {
        try
        {
          info.Text = "Wait forever...";
          await new Service1Client().DoTimeoutTaskAsync();
        }
        catch (Exception ex)
        {
          info.Text = ex.Message;
        }
      }
  }
}
