﻿using System;
using System.Net;
using System.ServiceModel;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

// ReSharper disable CheckNamespace

namespace TaskBasedWebOperations.ServiceReference1
{
  /// <summary>
  /// Method 1: As partial class.
  /// </summary>
  public partial class Service1Client
  {
    public Task DoActionTaskAsync(string s, double d, DateTime t)
    {
      return Task.Factory.FromAsync(Channel.BeginDoAction(s, d, t, null, null), Channel.EndDoAction);
    }

    public Task<string> DoThisTaskAsync(string s)
    {
      return Task<string>.Factory.FromAsync(Channel.BeginDoThis(s, null, null), Channel.EndDoThis);
    }

    public Task<int> DoThatTaskAsync(string s, int n)
    {
      return Task<int>.Factory.FromAsync(Channel.BeginDoThat(s, n, null, null), Channel.EndDoThat);
    }

    public Task DoExceptionTaskAsync()
    {
      return Task.Factory.FromAsync(Channel.BeginDoException(null, null), Channel.EndDoException);
    }

    public Task DoTimeoutTaskAsync()
    {
      return Task.Factory.FromAsync(Channel.BeginDoTimeout(null, null), Channel.EndDoTimeout);
    }

    public Task OpenTaskAsync()
    {
      return Task.Factory.FromAsync(((ICommunicationObject)this).BeginOpen(null, null),
                                    result => ((ICommunicationObject)this).EndOpen(result));
    }

    public Task CloseTaskAsync()
    {
      return Task.Factory.FromAsync(((ICommunicationObject)this).BeginClose(null, null),
                                    result => ((ICommunicationObject)this).EndClose(result));
    }
  }


  /// <summary>
  /// Method 2: As derived class.
  /// </summary>
  public class Service1Client2 : Service1Client
  {
    public new Task DoActionAsync(string s, double d, DateTime t)
    {
      return Task.Factory.FromAsync(Channel.BeginDoAction(s, d, t, null, null), Channel.EndDoAction);
    }

    public new Task<string> DoThisAsync(string s)
    {
      return Task<string>.Factory.FromAsync(Channel.BeginDoThis(s, null, null), Channel.EndDoThis);
    }

    public new Task<int> DoThatAsync(string s, int n)
    {
      return Task<int>.Factory.FromAsync(Channel.BeginDoThat(s, n, null, null), Channel.EndDoThat);
    }

    public new Task DoExceptionAsync()
    {
      return Task.Factory.FromAsync(Channel.BeginDoException(null, null), Channel.EndDoException);
    }

    public new Task DoTimeoutAsync()
    {
      return Task.Factory.FromAsync(Channel.BeginDoTimeout(null, null), Channel.EndDoTimeout);
    }
  }
}